unit fmComClient;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, OleServer, StdCtrls, ActiveX,
  ComServiceWithEvents_Import;

type
  TComClientWithEventsForm = class(TForm)
    EventsHandler: TComObjectWithEvents;
    BnInitEvent: TButton;
    MEventsList: TMemo;
    procedure EventsHandlerHandleEventNotification(ASender: TObject;
      const EventMessage: WideString);
    procedure BnInitEventClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ComClientWithEventsForm: TComClientWithEventsForm;

implementation

{$R *.dfm}

procedure TComClientWithEventsForm.EventsHandlerHandleEventNotification(ASender: TObject;
  const EventMessage: WideString);
begin
    MEventsList.Lines.Add(FormatDateTime('HH:NN:SS', Now)+' '+EventMessage);
end;

procedure TComClientWithEventsForm.BnInitEventClick(Sender: TObject);
begin
    EventsHandler.RaiseEvent('Some text');
end;

procedure TComClientWithEventsForm.FormCreate(Sender: TObject);
begin
    EventsHandler.Connect;
end;

initialization
  CoInitialize(nil);
  CoInitializeSecurity (nil, -1, nil, nil, 1, 1, nil, 0, nil);
finalization
  CoUninitialize;
end.
